%define PCRE %{nil}
%define LDAP %{nil}
%define SASL SASL
%define MYSQL %{nil}

Name: postfix
Summary: Postfix Mail Transport Agent
Group: System Environment/Daemons
Version: 20011125
URL: http://www.postfix.org/
Source: http://postfixftp.eunet.fi/experimental/snapshot-%{version}.tar.bz2
Source1: postfix-README_rpm.txt
Source2: postfix-README_maildrop_security.txt
Source3: postfix-init_script.sh
Source4: postfix-cron.daily.sh
Source5: postfix-aliases
%define tls pfixtls-0.7.13b-snap20011125-0.9.6b
Source6: http://www.aet.tu-cottbus.de/personen/jaenicke/pfixtls/%{tls}.tar.bz2
Patch0: postfix-20011008-chroot.patch
Patch1: postfix-config.patch
Patch2: postfix-chroot_chk.patch
Patch4: postfix-nonroot.patch
Patch5: postfix-20000924-ulimit.patch
Patch6: postfix-installsh-braindamage.patch
License: IBM Public License -- see LICENSE for details
BuildPrereq: openssl-devel
Provides: MTA smtpd smtpdaemon
Conflicts: sendmail, exim
Requires: openssl, setup >= 2.3.5, initscripts >= 5.53
Requires(post,preun): chkconfig, fileutils
Requires(post): diffutils
Release: 1%{PCRE}%{LDAP}%{SASL}%{MYSQL}
BuildRoot: %{_tmppath}/%{name}-%{version}-root
%if "%{LDAP}" != ""
BuildPrereq: openldap-devel
Requires: openldap
%endif
%if "%{PCRE}" != ""
Requires: pcre
BuildRequires: pcre-devel
%endif
%if "%{MYSQL}" != ""
Requires: mysql
BuildRequires: mysql-devel
%endif
%if "%{SASL}" != ""
Requires: cyrus-sasl >= 1.5.5
BuildRequires: cyrus-sasl-devel >= 1.5.5
%endif

%description
Postfix, see http://www.postfix.org/, aims to be an alternative to the
widely-used sendmail program, which is responsible for 70 percent of
all e-mail delivered on the Internet.

Although IBM supported the Postfix development, it abstains from control
over its evolution.  The goal is to have Postfix installed on as many
systems as possible.  To this end, the software is given away with no
strings attached, so that it can evolve with input from and under control
of its users.

Be sure to read http://www.moongroup.com/postfix-faq/c22.html which covers
steps which should be taken prior to and after the installation of Postfix.

%define config_directory /etc/postfix
%define daemon_directory /usr/libexec/postfix
%define command_directory /usr/sbin
%define queue_directory /var/spool/postfix
%define newaliases_path /usr/bin/newaliases

%define mailq_path /usr/bin/mailq
%define rmail_path /usr/bin/rmail

%define init_directory /etc/rc.d/init.d
%define sendmail_path /usr/sbin/sendmail
%define cron_directory /etc/cron.daily

%define whinge logger -p mail.info -t postfix/rpm

%prep
umask 022

%setup -q -n snapshot-%{version} -a 6
# Do this if the official tls patch applies
patch -p1 -b -z .tls <%{tls}/pfixtls.diff
rm -f conf/*.tls
%patch0 -p1 -b .chroot
%patch1 -p1 -b .config
%patch2 -p1 -b .chk
%patch4 -p1 -b .nonroot
%patch5 -p1 -b .ulimit
%patch6 -p1 -b .braindamage

# Move around the TLS docs
mkdir html/TLS
mv %{tls}/doc/* html/TLS
for i in ACKNOWLEDGEMENTS CHANGES INSTALL README TODO; do
  mv %{tls}/$i $i.TLS
done

# Copy README files allowing us to just go %doc below, and have rpm(1)
# automatically tuck it in alongside the READMEs and COPYRIGHTs.
cp ${RPM_SOURCE_DIR}/postfix-README_rpm.txt README_rpm.txt
cp ${RPM_SOURCE_DIR}/postfix-README_maildrop_security.txt \
	README_maildrop_security.txt

%build
umask 022
FLAGS="$RPM_OPT_FLAGS -DHAS_SSL -I/usr/include/openssl"
LIBS="-lssl -lcrypto"
%if "%{LDAP}" != ""
FLAGS="$FLAGS -DHAS_LDAP"
LIBS="$LIBS -lldap -llber"
%endif
%if "%{PCRE}" != ""
FLAGS="$FLAGS -DHAS_PCRE `pcre-config --cflags`"
LIBS="$LIBS -lpcre"
%endif
%if "%{MYSQL}" != ""
FLAGS="$FLAGS -DHAS_MYSQL -I/usr/include/mysql"
LIBS="$LIBS -lmysqlclient -lm"
%endif
%if "%{SASL}" != ""
FLAGS="$FLAGS -DUSE_SASL_AUTH"
LIBS="$LIBS -lsasl"
%endif
make DEBUG="" OPT="$FLAGS" AUXLIBS="$LIBS"

%install
umask 022
/bin/rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}

strip -R .comment --strip-unneeded bin/* libexec/*

echo "$RPM_BUILD_ROOT"
set -x
sh INSTALL.sh <<EOF
$RPM_BUILD_ROOT
$RPM_BUILD_DIR/snapshot-%{version}
%{config_directory}
%{daemon_directory}
%{command_directory}
%{queue_directory}
%{sendmail_path}
%{newaliases_path}
%{mailq_path}
mail
mail
%{_mandir}
EOF

# Change the default directory for alias_maps and alias_database
# to %{config_directory}
bin/postconf -c ${RPM_BUILD_ROOT}%{config_directory} -e \
	"alias_maps = hash:%{config_directory}/aliases" \
	"alias_database = hash:%{config_directory}/aliases" \
|| exit 1 

# This installs into the /etc/rc.d/init.d directory
mkdir -p ${RPM_BUILD_ROOT}%{init_directory}
install -c ${RPM_SOURCE_DIR}/postfix-init_script.sh ${RPM_BUILD_ROOT}%{init_directory}/postfix

# These set up the chroot directory structure
mkdir -p ${RPM_BUILD_ROOT}%{queue_directory}/etc
mkdir -p ${RPM_BUILD_ROOT}%{queue_directory}/lib
mkdir -p ${RPM_BUILD_ROOT}%{queue_directory}/flush
mkdir -p ${RPM_BUILD_ROOT}%{queue_directory}/usr/lib/zoneinfo

# This is the /etc/cron.daily directory
mkdir -p ${RPM_BUILD_ROOT}%{cron_directory}

install -c ${RPM_SOURCE_DIR}/postfix-cron.daily.sh ${RPM_BUILD_ROOT}%{cron_directory}/postfix
install -c auxiliary/rmail/rmail ${RPM_BUILD_ROOT}%{rmail_path}

gzip -9f ${RPM_BUILD_ROOT}%{_mandir}/man{1,5,8}/* ||:

#
# copy new aliases files and build the aliases.db (ghost) file
#
cp -f  ${RPM_SOURCE_DIR}/postfix-aliases ${RPM_BUILD_ROOT}%{config_directory}/aliases
chmod 644 ${RPM_BUILD_ROOT}%{config_directory}/aliases
${RPM_BUILD_ROOT}/%{command_directory}/postalias -c ${RPM_BUILD_ROOT}/%{config_directory} ${RPM_BUILD_ROOT}/%{config_directory}/aliases


mkdir -p $RPM_BUILD_ROOT/var/spool/postfix/active
mkdir -p $RPM_BUILD_ROOT/var/spool/postfix/bounce
mkdir -p $RPM_BUILD_ROOT/var/spool/postfix/corrupt
mkdir -p $RPM_BUILD_ROOT/var/spool/postfix/defer
mkdir -p $RPM_BUILD_ROOT/var/spool/postfix/deferred
mkdir -p $RPM_BUILD_ROOT/var/spool/postfix/incoming
mkdir -p $RPM_BUILD_ROOT/var/spool/postfix/pid
mkdir -p $RPM_BUILD_ROOT/var/spool/postfix/private
mkdir -p $RPM_BUILD_ROOT/var/spool/postfix/public
mkdir -p $RPM_BUILD_ROOT/var/spool/postfix/saved



# The post script executes after the package has been installed.  Here
# we put things that invoke files we just installed, and populate the
# directories we've created with local-dependent files.
%post
umask 022
/sbin/chkconfig --add postfix
%{newaliases_path}
install -c -m 644 /etc/localtime /etc/services /etc/resolv.conf %{queue_directory}/etc
%{command_directory}/postfix check >/dev/null

# If a relevant package is updated, update our changeroot environment
%triggerin -- setup
install -c -m 644 /etc/services %{queue_directory}/etc

%if "%{LDAP}" != "%{nil}"
%triggerin -- openldap
if [ -e /usr/lib/libldap.so.1 ]; then
    cmp -s /usr/lib/libldap.so.1 %{queue_directory}/usr/lib/libldap.so.1 \
        2>/dev/null || \
        install -c /usr/lib/libldap.so.1 %{queue_directory}/usr/lib
fi
if [ -e /usr/lib/liblber.so.1 ]; then
    cmp -s /usr/lib/liblber.so.1 %{queue_directory}/usr/lib/liblber.so.1 \
        2>/dev/null || \
        install -c /usr/lib/liblber.so.1 %{queue_directory}/usr/lib
fi
%endif

%triggerin -- glibc
umask 022
install -c -m 644 /etc/localtime %{queue_directory}/etc
ln -sf /etc/localtime %{queue_directory}/usr/lib/zoneinfo

if [ -e /lib/libnss_dns.so.2 ]; then
    cmp -s /lib/libnss_dns.so.2 %{queue_directory}/lib/libnss_dns.so.2 2>/dev/null || \
        install -c /lib/libnss_dns.so.2 %{queue_directory}/lib
else
    if [ -e /lib/libnss_dns.so.1 ]; then
        cmp -s /lib/libnss_dns.so.1 %{queue_directory}/lib/libnss_dns.so.1 2>/dev/null || \
        install -c /lib/libnss_dns.so.1 %{queue_directory}/lib
    fi
fi

%preun
umask 022
if [ "$1" = 0 ]; then
    %{command_directory}/postfix stop
    /sbin/chkconfig --del postfix                    

    rm -f %{queue_directory}/etc/localtime
    rm -f %{queue_directory}/etc/services
    rm -f %{queue_directory}/etc/resolv.conf
    rm -f %{queue_directory}/usr/lib/zoneinfo/localtime
    rm -f %{queue_directory}/lib/libnss_dns.so.1
    rm -f %{queue_directory}/lib/libnss_dns.so.2
fi

%postun
if [ "$1" != 0 ]; then
    (%{command_directory}/postfix stop && sleep 2 && %{command_directory}/postfix start) || true
fi

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(0755, root, root)
%attr(0755, root, root) %dir %{config_directory}
%config %attr(0755, root, root) %{config_directory}/postfix-script
%config(noreplace) %attr(0644, root, root) %{config_directory}/main.cf
%config %attr(0644, root, root) %{config_directory}/master.cf
%config %attr(0644, root, root) %{config_directory}/install.cf
%config(noreplace) %attr(0644, root, root) %{config_directory}/aliases
%attr(0644, root, root) %ghost             %{config_directory}/aliases.db

%attr(0755, root, root) %{init_directory}/postfix
%dir %attr(-, root, root) %{queue_directory}
%dir %attr(-, root, root) %{queue_directory}/etc
%dir %attr(-, root, root) %{queue_directory}/lib
%dir %attr(-, root, root) %{queue_directory}/usr/lib
%dir %attr(-, root, root) %{queue_directory}/usr/lib/zoneinfo

%dir %attr(0700, mail, root) %{queue_directory}/active
%dir %attr(0700, mail, root) %{queue_directory}/bounce
%dir %attr(0700, mail, root) %{queue_directory}/corrupt
%dir %attr(0700, mail, root) %{queue_directory}/defer
%dir %attr(0700, mail, root) %{queue_directory}/deferred
%dir %attr(0700, mail, root) %{queue_directory}/flush
%dir %attr(0700, mail, root) %{queue_directory}/incoming
%dir %attr(1730, mail, mail) %{queue_directory}/maildrop
%dir %attr(0755, mail, root) %{queue_directory}/pid
%dir %attr(0700, mail, root) %{queue_directory}/private
%dir %attr(0755, mail, root) %{queue_directory}/public
%dir %attr(0700, mail, root) %{queue_directory}/saved
%attr(0755, root, root) %{cron_directory}/postfix

%doc 0README BEWARE COMPATIBILITY DEBUG_README HISTORY INSTALL INSTALL.sh
%doc LDAP_README LICENSE MYSQL_README PCRE_README PORTING
%doc README_maildrop_security.txt README_rpm.txt RELEASE_NOTES
%doc RESTRICTION_CLASS TODO ULTRIX_README UUCP_README

%doc README_rpm.txt README_maildrop_security.txt

%doc conf/access conf/aliases conf/canonical conf/main.cf
%doc conf/main.cf.default conf/master.cf conf/postfix-script
%doc conf/postfix-script-nosgid conf/postfix-script-sgid conf/relocated
%doc conf/sample-*.cf
%doc conf/transport
%doc conf/virtual
%if "%{SASL}" != ""
%doc SASL_README
%endif

%doc ACKNOWLEDGEMENTS.TLS CHANGES.TLS README.TLS TODO.TLS html/TLS/*

%doc html

%attr(0755, root, root) %dir %{daemon_directory}
%{daemon_directory}/*

%{command_directory}/postalias
%{command_directory}/postcat
%{command_directory}/postconf
%attr(2755, root, mail) %{command_directory}/postdrop
%{command_directory}/postfix
%{command_directory}/postkick
%{command_directory}/postlock
%{command_directory}/postlog
%{command_directory}/postmap
%{command_directory}/postsuper

%{sendmail_path}
%{mailq_path}
%{newaliases_path}
%attr(0755, root, root) %{rmail_path}

%{_mandir}/*/*

%changelog
* Tue Nov 27 2001 Bernhard Rosenkraenzer <bero@redhat.com> 20011125-1
- Update to 20011125, fixing 64bit problems.

* Mon Nov 19 2001 Bernhard Rosenkraenzer <bero@redhat.com> 20011116-1
- Update to 20011116
- Fix bug #43

* Thu Nov 15 2001 Bernhard Rosenkraenzer <bero@redhat.com> 20011115-1
- Update to 20011115, fixing security bug (memory exhaustion bug)

* Thu Nov  8 2001 Bernhard Rosenkraenzer <bero@redhat.com> 20011105-1
- Update to 20011105, TLS 0.7.12

* Tue Sep  4 2001 Bernhard Rosenkraenzer <bero@redhat.com> 20010808-1
- Update to 20010808, TLS 0.7.8

* Fri Jun 29 2001 Bernhard Rosenkraenzer <bero@redhat.com> 20010610-1
- Update to 20010610, TLS 0.7.3a
- Add SASL support, based on Patch from Karl O. Pinc <kop@meme.com> (#44747)

* Mon May 28 2001 Bernhard Rosenkraenzer <bero@redhat.com> 20010525-1
- Update to 20010525, TLS 0.7.3
- Remove %verify(not md5)s (#41806)
- Add triggers to automatically update glibc and friends in the chroot jail
- Use nqmgr by default; if it's good enough for bero.org, it's good enough
  for anyone. ;)

* Thu May  3 2001 Bernhard Rosenkraenzer <bero@redhat.com> 20010502-1
- Update to 20010502

* Wed Apr 25 2001 Bernhard Rosenkraenzer <bero@redhat.com> 20010329-1
- Postfix 20010329, TLS 0.7.1
- Add PCRE support
- Add plug for compiling with MySQL support, leave it disabled by default

* Fri Mar 16 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- 20010228, TLS 0.7.0

* Fri Mar  2 2001 Tim Powers <timp@redhat.com>
- rebuilt against openssl-0.9.6-1

* Thu Feb 15 2001 Nalin Dahyabhai <nalin@redhat.com>
- fix init script

* Tue Feb 13 2001 Tim Powers <timp@redhat.com>
- added conflict with exim

* Sun Feb  4 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- 20010202
- TLS 0.6.35
- Fix INSTALL.sh braindamage introduced in new version

* Tue Jan 23 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- i18nify init script
- TLS 0.6.33
- bzip2 source

* Wed Jan  3 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- TLS 0.6.31
- Require openssl, BuildPrereq openssl-devel (#23155)
- Fix up dependencies (split Prereq in Requires(post), Requires(preun), etc.

* Mon Dec 18 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 20001217, TLS 0.6.30

* Thu Nov 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Update to 20001121
- Update to PostfixTLS 0.6.24
- Require setup >= 2.3.5 (we need to know about the smtps
  and submission services)

* Tue Nov 14 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Add the Postfix-TLS patch

* Tue Oct 31 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Update to 20001030

* Fri Sep 29 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Update to 20000924
- Run newaliases in %post (postfix doesn't run if it can't access the
  alias databases.)
- Fix a relatively major glibc 2.2 interoperability problem - the maximum
  size of the mailspool is NOT supposed to be the maximum size of a message.

* Thu Aug 17 2000 Than Ngo <than@redhat.de>
- added missing directories (Bug #16404)

* Thu Aug  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Add optional LDAP support (Bug #14680), leave it disabled by default
  to avoid additional dependencies
- Add nqmgr (Bug #14680)

* Wed Aug  2 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Add some missing directories (Bug #13667 and some non-reported issues)

* Mon Jul 24 2000 Prospector <prospector@redhat.com>
- rebuilt

* Mon Jul 17 2000 Tim Powers <timp@redhat.com>
- inits now in rc.d/init.d again

* Thu Jul 06 2000 Tim Powers <timp@redhat.com>
- fixed PreReq to PreReq /etc/init.d

* Thu Jul  6 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- FHSify

* Mon Jun 19 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 20000531
- clean up the spec file - it's a huge mess...
- FHSify
- fix build as user
- fix compilation with glibc 2.2

* Thu Jan 13 2000 Tim Powers <timp@redhat.com>
- removing the whinge stuff from the pre and post sections to meet Red Hat
	policy
- quiet setup 
- built for Powertools 6.2

* Thu Jan 13 2000 Simon Mudd <sjmudd@pobox.com>
- fix the postalias command which needed the '-c' option
  specified.  (Edward S. Marshall <emarshal@logic.net>)

- fix the rpm-3.x problem with defines not being commented out
  and comment that part of the spec file so that I don't get
  caught again. (It works on my platform with rpm-2.x!)

* Tue Jan 04 2000 Simon Mudd <sjmudd@pobox.com>
- update to work with postfix-19991231-pl02

* Tue Jan 04 2000 Simon Mudd <sjmudd@pobox.com>
- update to work with postfix-19991231-pl01
- and the ghost parameter for aliases.db

* Tue Jan 04 2000 Simon Mudd <sjmudd@pobox.com>
- Fix BEWARE problem in doc
- change man page compression to work on required files

* Fri Dec 24 1999 Simon Mudd <sjmudd@pobox.com>
- update for 19991223 snapshot
- setup the alias_maps and alias_database parameters correctly
- rebuild aliases on install (should fix this to only do this if
  required)
- fix INSTALL.sh which didn't quite work

* Thu Dec 23 1999 Simon Mudd <sjmudd@pobox.com>
- modified the aliases file somewhat.
- re-enabled the whinging after ensuring that output will NOT go to
  stderr, but only syslog.

* Wed Dec 22 1999 Chuck Mead <chuck@moongroup.com>
- added an aliases file per discussions with Tim Powers

* Wed Dec 22 1999 Tim Powers <timp@redhat.com>
- changed group so that it's a valid Red Hat group
- commented out the whinge stuff in the %pre and %post sections to conform
	with Red Hat policy
- changed BuildRoot to be in /var/tmp
- gzip man pages
- changed %%{manpath} reference in %files section so that this package doesn't
	claim ownership of /usr/man
- commented out the Patch99 stuff since we don't need it

* Fri Dec 17 1999 Simon J Mudd <sjmudd@pobox.com>
  [19991216-1]: update for new snapshot

* Mon Dec 13 1999 Simon J Mudd <sjmudd@pobox.com>
  [19991126-1]: update for new snapshot

* Sat Dec 03 1999 Simon J Mudd <sjmudd@pobox.com>
  [19991126-1]: update for new snapshot

* Fri Nov 26 1999 Simon J Mudd <sjmudd@pobox.com>
  [19991123-4]: /etc/cron.daily/postfix was installed as well as a crontab
                - remove the crontab entry as this isn't necessary
  [19991123-3]: add a small delay between postfix stop && postfix start
  [19991123-2]: Wietse's rbl code needed, patching - include the patch

* Tue Nov 23 1999 Simon J Mudd <sjmudd@pobox.com>
  [19991123-1]: try the snapshot which looks nice (?)

* Mon Nov 22 1999 Simon J Mudd <sjmudd@pobox.com>
  [19990906-pl07-1]: patch against pl07

* Thu Nov 17 1999 Simon J Mudd <sjmudd@pobox.com>
  [19990906-pl06-2]: tidy up spec file and include rmail
